import { useState, useRef, useEffect } from 'react';

var useIntervalTimer = function (_a) {
    var _b = _a.interval, interval = _b === void 0 ? 100 : _b, _c = _a.maxTicks, maxTicks = _c === void 0 ? 0 : _c;
    var _d = useState(1), tick = _d[0], setTickState = _d[1];
    var _e = useState(true), started = _e[0], setStarted = _e[1];
    var tickRef = useRef(tick);
    var startedRef = useRef(started);
    useEffect(function () {
        var update = function () {
            if (!startedRef.current) {
                return;
            }
            if (maxTicks <= 0 || tickRef.current < maxTicks) {
                tickRef.current = tickRef.current + 1;
                setTickState(tickRef.current);
                window.setTimeout(update, interval);
            }
            else {
                setStarted(false);
            }
        };
        var timer = window.setTimeout(update, interval);
        return function () { return window.clearTimeout(timer); };
    }, [interval, maxTicks, started]);
    var stop = function () {
        startedRef.current = false;
        setStarted(false);
    };
    var start = function () {
        startedRef.current = true;
        setStarted(true);
    };
    var setTick = function (tick) {
        tickRef.current = tick;
        setTickState(tick);
    };
    return { tick: tick, started: started, stop: stop, start: start, setTick: setTick };
};

export default useIntervalTimer;
//# sourceMappingURL=index.es.js.map
